<script>
	import { isBeingAdjustedStore } from './store';
	export let actualPosition = 1;
	export let controlPosition = 1;

	/** Frame **/
	export let frameWidth = 300;
	export let frameHeight = 500;
	export let frameDepth = 16;
	let horizFrameColor = '#E4E4E4';
	let vertFrameColor = '#E9E9E9';

	/** Roll **/
	export let rollHeight = 30;
	export let rollVertPadding = 8;
	let rollBorderRadius = 3;
	let rollHorizPadding = 4;

	/** Jacket **/
	export let jacketHeight =
		frameHeight -
		rollHeight +
		rollVertPadding -
		frameDepth * 1.5;
	let jacketHorizOffset = -4;
	let jacketBorderRadius = 2;

	let isBeingAdjusted;
	isBeingAdjustedStore.subscribe((value) => {
		isBeingAdjusted = value;
	});
</script>

<style>
	.container {
		position: relative;
		border: 1px solid black;
	}
	#roll {
		background-image: linear-gradient(
			179deg,
			#c2c1c1 0%,
			#cecece 35%
		);
	}
	#jacket-ghost {
		opacity: 0.35;
	}
	#jacket-ghost-path {
		transition: opacity 0.5s;
	}
	#jacket-ghost-path.hidden {
		opacity: 0;
	}
</style>

<main>
	<svg
		width="{frameWidth}px"
		height="{frameHeight}px"
		viewBox="0 0 {frameWidth} {frameHeight}"
		version="1.1">
		<title>Path</title>
		<defs>
			<!-- Jacket Ghost -->
			<rect
				class:hidden={!isBeingAdjusted}
				id="jacket-ghost-path"
				x={rollHorizPadding - jacketHorizOffset}
				y={rollVertPadding + rollHeight - jacketBorderRadius}
				width={frameWidth - rollHorizPadding * 2 + jacketHorizOffset * 2}
				height={jacketHeight * controlPosition}
				rx={jacketBorderRadius} />
			<filter
				x="-1.9%"
				y="-3.2%"
				width="103.8%"
				height="109.1%"
				filterUnits="objectBoundingBox"
				id="jacket-ghost-shadow">
				<feOffset
					dx="0"
					dy="2"
					in="SourceAlpha"
					result="shadowOffsetOuter1" />
				<feGaussianBlur
					stdDeviation="2"
					in="shadowOffsetOuter1"
					result="shadowBlurOuter1" />
				<feColorMatrix
					values="0 0 0 0 0   0 0 0 0 0   0 0 0 0 0  0 0 0 0.3 0"
					type="matrix"
					in="shadowBlurOuter1" />
			</filter>
			<!-- Jacket -->
			<rect
				id="jacket-path"
				x={rollHorizPadding - jacketHorizOffset}
				y={rollVertPadding + rollHeight - jacketBorderRadius}
				width={frameWidth - rollHorizPadding * 2 + jacketHorizOffset * 2}
				height={jacketHeight * actualPosition}
				rx={jacketBorderRadius} />
			<filter
				x="-1.9%"
				y="-3.2%"
				width="103.8%"
				height="109.1%"
				filterUnits="objectBoundingBox"
				id="jacket-shadow">
				<feOffset
					dx="0"
					dy="2"
					in="SourceAlpha"
					result="shadowOffsetOuter1" />
				<feGaussianBlur
					stdDeviation="2"
					in="shadowOffsetOuter1"
					result="shadowBlurOuter1" />
				<feColorMatrix
					values="0 0 0 0 0   0 0 0 0 0   0 0 0 0 0  0 0 0 0.175 0"
					type="matrix"
					in="shadowBlurOuter1" />
			</filter>

			<!-- Roll -->
			<linearGradient
				x1="50%"
				y1="0%"
				x2="50%"
				y2="34.5455737%"
				id="linearGradient-1">
				<stop stop-color="#C2C1C1" offset="0%" />
				<stop stop-color="#CECECE" offset="100%" />
			</linearGradient>
			<rect
				id="roll-path"
				x={rollHorizPadding}
				y={rollVertPadding}
				width={frameWidth - rollHorizPadding * 2}
				height={rollHeight}
				rx={rollBorderRadius} />
			<filter
				x="-1.8%"
				y="-15.6%"
				width="103.7%"
				height="143.8%"
				filterUnits="objectBoundingBox"
				id="filter-3">
				<feMorphology
					radius="0.5"
					operator="dilate"
					in="SourceAlpha"
					result="shadowSpreadOuter1" />
				<feOffset
					dx="0"
					dy="2"
					in="shadowSpreadOuter1"
					result="shadowOffsetOuter1" />
				<feGaussianBlur
					stdDeviation="1.5"
					in="shadowOffsetOuter1"
					result="shadowBlurOuter1" />
				<feColorMatrix
					values="0 0 0 0 0   0 0 0 0 0   0 0 0 0 0  0 0 0 0.0732899913 0"
					type="matrix"
					in="shadowBlurOuter1" />
			</filter>
		</defs>
		<!-- Frame -->
		<g id="frame" stroke="none" fill="none">
			<polygon
				id="top"
				fill={horizFrameColor}
				points="0 0 {frameWidth} 0 {frameWidth - frameDepth} {frameDepth} {frameDepth} {frameDepth}" />
			<polygon
				id="left"
				fill={vertFrameColor}
				points="0 0 {frameDepth} {frameDepth} {frameDepth} {frameHeight - frameDepth} 0 {frameHeight}" />
			<polygon
				id="bottom"
				fill={horizFrameColor}
				points="0 {frameHeight} {frameWidth} {frameHeight} {frameWidth - frameDepth} {frameHeight - frameDepth} {frameDepth} {frameHeight - frameDepth}" />
			<polygon
				id="right"
				fill={vertFrameColor}
				points="{frameWidth} 0 {frameWidth} {frameHeight} {frameWidth - frameDepth} {frameHeight - frameDepth} {frameWidth - frameDepth} {frameDepth}" />
		</g>
		<!-- Jacket Ghost -->
		<g id="jacket-ghost" stroke="none" fill="none">
			<g>
				<use
					fill="black"
					fill-opacity="1"
					filter="url(#jacket-ghost-shadow)"
					xlink:href="#jacket-ghost-path" />
				<use
					fill="#CCCCCC"
					fill-rule="evenodd"
					xlink:href="#jacket-ghost-path" />
			</g>
		</g>
		<!-- Jacket -->
		<g id="jacket" stroke="none" fill="none">
			<g>
				<use
					fill="black"
					fill-opacity="1"
					filter="url(#jacket-shadow)"
					xlink:href="#jacket-path" />
				<use
					fill="#CCCCCC"
					fill-rule="evenodd"
					xlink:href="#jacket-path" />
			</g>
		</g>
		<!-- Roll -->
		<g id="roll-container">
			<use
				id="roll-shadow"
				fill="black"
				fill-opacity="1"
				filter="url(#filter-3)"
				xlink:href="#roll-path" />
			<use
				id="roll"
				fill="url(#linearGradient-1)"
				fill-rule="evenodd"
				xlink:href="#roll-path" />
		</g>
	</svg>
</main>
